"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  Bootstrap: () => Bootstrap,
  ConfigModule: () => ConfigModule,
  ConfigService: () => import_pulumi2.Config,
  LoggerService: () => LoggerService
});
module.exports = __toCommonJS(src_exports);

// src/bootstrap/bootstrap.ts
var import_core = require("@nestjs/core");

// src/logger/logger.ts
var import_pulumi = require("@pulumi/pulumi");
var import_colorette = require("colorette");
var import_util = require("util");

// src/logger/logger.constants.ts
var LogLevels;
(function(LogLevels2) {
  LogLevels2["ERROR"] = "ERROR";
  LogLevels2["WARN"] = "WARN";
  LogLevels2["INFO"] = "INFO";
  LogLevels2["DEBUG"] = "DEBUG";
})(LogLevels || (LogLevels = {}));

// src/logger/logger.ts
var colors = (0, import_colorette.createColors)({
  useColor: true
});
var LoggerService = class {
  static {
    __name(this, "LoggerService");
  }
  context;
  color;
  constructor(context) {
    this.context = context;
    this.color = {
      [LogLevels.ERROR]: colors.red,
      [LogLevels.WARN]: colors.yellow,
      [LogLevels.INFO]: colors.green,
      [LogLevels.DEBUG]: colors.magenta
    };
  }
  async error(message, trace, context) {
    await import_pulumi.log.error(this.printf(LogLevels.ERROR, message, context));
    if (trace) {
      await import_pulumi.log.debug(this.printf(LogLevels.DEBUG, trace, context));
    }
  }
  async warn(message, context) {
    return import_pulumi.log.warn(this.printf(LogLevels.WARN, message, context));
  }
  async log(message, context) {
    return import_pulumi.log.info(this.printf(LogLevels.INFO, message, context));
  }
  async debug(message, context) {
    return import_pulumi.log.debug(this.printf(LogLevels.DEBUG, message, context));
  }
  printf(level, message, context) {
    const prefix = `${this.color[level](`[${this.context ?? context}]`)} `;
    if (typeof message === "string") {
      return prefix + colors.yellow(message);
    }
    message[0] = prefix + message[0];
    return colors.yellow((0, import_util.format)(...message));
  }
};

// src/bootstrap/bootstrap.ts
var Bootstrap = class {
  static {
    __name(this, "Bootstrap");
  }
  static async create(mod) {
    const app = await import_core.NestFactory.createApplicationContext(mod, {
      logger: new LoggerService()
    });
    return app;
  }
};

// src/config/config.interface.ts
var import_pulumi2 = require("@pulumi/pulumi");

// src/config/config.module.ts
var import_common = require("@nestjs/common");
function _ts_decorate(decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
}
__name(_ts_decorate, "_ts_decorate");
var ConfigModule = class {
  static {
    __name(this, "ConfigModule");
  }
};
ConfigModule = _ts_decorate([
  (0, import_common.Module)({
    providers: [
      {
        provide: import_pulumi2.Config,
        useFactory: () => new import_pulumi2.Config()
      }
    ],
    exports: [
      import_pulumi2.Config
    ]
  })
], ConfigModule);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Bootstrap,
  ConfigModule,
  ConfigService,
  LoggerService
});
//# sourceMappingURL=index.cjs.map